Index: TXM/trunk/org.txm.backtomedia.rcp/src/org/txm/backtomedia/commands/function/BackToMedia.java
===================================================================
--- TXM/trunk/org.txm.backtomedia.rcp/src/org/txm/backtomedia/commands/function/BackToMedia.java	(revision 3421)
+++ TXM/trunk/org.txm.backtomedia.rcp/src/org/txm/backtomedia/commands/function/BackToMedia.java	(revision 3422)
@@ -182,8 +182,7 @@
 			String[] ids = panel.getWordSelection();
 			// System.out.println("Words: "+Arrays.toString(ids));
 			if (ids == null || ids[0] == null) {
-				// no word detected or selected
-				return null;
+				return backToMedia(cqpCorpus, text.getName(), "0.0", null, editor, HandlerUtil.getActiveWorkbenchWindow(event).getShell());
 			}
 			else if (ids[1] == null) { // only one word is selected -> using sync_mode preferences
 				try {
Index: TXM/trunk/org.txm.backtomedia.rcp/src/org/txm/backtomedia/editors/player/HTMLPlayer.java
===================================================================
--- TXM/trunk/org.txm.backtomedia.rcp/src/org/txm/backtomedia/editors/player/HTMLPlayer.java	(revision 3421)
+++ TXM/trunk/org.txm.backtomedia.rcp/src/org/txm/backtomedia/editors/player/HTMLPlayer.java	(revision 3422)
@@ -50,7 +50,10 @@
 		
 		browser = new Browser(this, SWT.NONE);
 		browser.setLayoutData(new GridData(GridData.FILL, GridData.FILL, true, true));
-		browser.setText("<!DOCTYPE html><html><head><meta http-equiv=\"content-type\" content=\"text/html; charset=UTF-8\"></head><body><video style=\"height:100%;\"id=\"video\" controls></video></body></html>");
+		//browser.setText("<!DOCTYPE html><html><head><meta http-equiv=\"content-type\" content=\"text/html; charset=UTF-8\"></head><body><video id=\"video\" controls></video></body></html>");
+		String html = "<!DOCTYPE html><html><head><meta http-equiv=\"content-type\" content=\"text/html; charset=UTF-8\"></head><body><video id=\"video\" style=\"object-fit:contain;\" controls controlsList=\"nofullscreen\"></video></body></html>";
+		System.out.println(html);
+		browser.setText(html);
 		//browser.setText("<video id=\"video\" width=\"100%\" height=\"100%\" controls><source id=\"source\" src=\"\"></source></video>");
 		
 		browser.addProgressListener(new ProgressListener() {
@@ -98,9 +101,9 @@
 			@Override
 			public void widgetDefaultSelected(SelectionEvent e) { }
 		});
-				
+		
 		browser.setMenu(menu);
-				
+		
 		GLComposite controls = new GLComposite(this, SWT.NONE, "controls");
 		controls.getLayout().numColumns = 20;
 		controls.getLayout().horizontalSpacing = 2;
@@ -148,74 +151,74 @@
 				public void widgetDefaultSelected(SelectionEvent e) { }
 			});
 			
-//			Button playpauseButton = new Button(controls, SWT.TOGGLE);
-//			playpauseButton.setText("Pause");
-//			playpauseButton.setSelection(true);
-//			playpauseButton.addSelectionListener(new SelectionListener() {
-//				
-//				@Override
-//				public void widgetSelected(SelectionEvent event) {
-//					if (playpauseButton.getSelection()) {
-//						resume();
-//						playpauseButton.setText("Pause");
-//					} else {
-//						pause();
-//						playpauseButton.setText("Play");
-//					}
-//				}
-//				
-//				@Override
-//				public void widgetDefaultSelected(SelectionEvent e) { }
-//			});
-//			
-//			Button replayButton = new Button(controls, SWT.PUSH);
-//			replayButton.setText("Re-play");
-//			replayButton.addSelectionListener(new SelectionListener() {
-//				
-//				@Override
-//				public void widgetSelected(SelectionEvent event) {
-//					replay();
-//				}
-//				
-//				@Override
-//				public void widgetDefaultSelected(SelectionEvent e) { }
-//			});
-//			
-//			Button loopButton = new Button(controls, SWT.TOGGLE);
-//			loopButton.setText("Loop");
-//			loopButton.setSelection(initRepeat);
-//			loopButton.addSelectionListener(new SelectionListener() {
-//				
-//				@Override
-//				public void widgetSelected(SelectionEvent event) {
-//					setRepeat(loopButton.getSelection());
-//				}
-//				
-//				@Override
-//				public void widgetDefaultSelected(SelectionEvent e) { }
-//			});
-//			
-//			volumeLabel = new Label(controls, SWT.NONE);
-//			volumeLabel.setText("Volume (100%)");
-//			
-//			Scale volumneSpinner = new Scale(controls, SWT.NONE);
-//			volumneSpinner.setMinimum(0);
-//			volumneSpinner.setMaximum(100);
-//			volumneSpinner.setSelection(100);
-//			volumneSpinner.addSelectionListener(new SelectionListener() {
-//				
-//				@Override
-//				public void widgetSelected(SelectionEvent e) {
-//					setVolume(volumneSpinner.getSelection());
-//				}
-//				
-//				@Override
-//				public void widgetDefaultSelected(SelectionEvent e) { }
-//			});
+			//			Button playpauseButton = new Button(controls, SWT.TOGGLE);
+			//			playpauseButton.setText("Pause");
+			//			playpauseButton.setSelection(true);
+			//			playpauseButton.addSelectionListener(new SelectionListener() {
+			//				
+			//				@Override
+			//				public void widgetSelected(SelectionEvent event) {
+			//					if (playpauseButton.getSelection()) {
+			//						resume();
+			//						playpauseButton.setText("Pause");
+			//					} else {
+			//						pause();
+			//						playpauseButton.setText("Play");
+			//					}
+			//				}
+			//				
+			//				@Override
+			//				public void widgetDefaultSelected(SelectionEvent e) { }
+			//			});
+			//			
+			//			Button replayButton = new Button(controls, SWT.PUSH);
+			//			replayButton.setText("Re-play");
+			//			replayButton.addSelectionListener(new SelectionListener() {
+			//				
+			//				@Override
+			//				public void widgetSelected(SelectionEvent event) {
+			//					replay();
+			//				}
+			//				
+			//				@Override
+			//				public void widgetDefaultSelected(SelectionEvent e) { }
+			//			});
+			//			
+			//			Button loopButton = new Button(controls, SWT.TOGGLE);
+			//			loopButton.setText("Loop");
+			//			loopButton.setSelection(initRepeat);
+			//			loopButton.addSelectionListener(new SelectionListener() {
+			//				
+			//				@Override
+			//				public void widgetSelected(SelectionEvent event) {
+			//					setRepeat(loopButton.getSelection());
+			//				}
+			//				
+			//				@Override
+			//				public void widgetDefaultSelected(SelectionEvent e) { }
+			//			});
+			//			
+			//			volumeLabel = new Label(controls, SWT.NONE);
+			//			volumeLabel.setText("Volume (100%)");
+			//			
+			//			Scale volumneSpinner = new Scale(controls, SWT.NONE);
+			//			volumneSpinner.setMinimum(0);
+			//			volumneSpinner.setMaximum(100);
+			//			volumneSpinner.setSelection(100);
+			//			volumneSpinner.addSelectionListener(new SelectionListener() {
+			//				
+			//				@Override
+			//				public void widgetSelected(SelectionEvent e) {
+			//					setVolume(volumneSpinner.getSelection());
+			//				}
+			//				
+			//				@Override
+			//				public void widgetDefaultSelected(SelectionEvent e) { }
+			//			});
 			
-//			GridData gdata = new GridData(GridData.CENTER, GridData.CENTER, false, false);
-//			gdata.minimumWidth = gdata.widthHint = 150;
-//			volumneSpinner.setLayoutData(gdata);
+			//			GridData gdata = new GridData(GridData.CENTER, GridData.CENTER, false, false);
+			//			gdata.minimumWidth = gdata.widthHint = 150;
+			//			volumneSpinner.setLayoutData(gdata);
 			
 			rateLabel = new Label(controls, SWT.NONE);
 			rateLabel.setText("Rate (1.0)");
@@ -322,15 +325,16 @@
 			start =  ((time1.getHour() * 60 * 60) + (time1.getMinute() * 60) + time1.getSecond());
 		}
 		
-		if (endTime.matches("[0-9]+.[0-9]+")) {
-			end = (int) ( Float.parseFloat(endTime));
+		if (endTime != null) {
+			if (endTime.matches("[0-9]+.[0-9]+")) {
+				end = (int) ( Float.parseFloat(endTime));
+			}
+			else if (endTime.matches("[0-9]+:[0-9]+:[0-9]+")) {
+				if (endTime.indexOf(":") == 1) endTime = "0" + endTime;
+				LocalTime time1 = LocalTime.parse(endTime, hhmmssFormatter);
+				end =  ((time1.getHour() * 60 * 60) + (time1.getMinute() * 60) + time1.getSecond());
+			}
 		}
-		else if (endTime.matches("[0-9]+:[0-9]+:[0-9]+")) {
-			if (endTime.indexOf(":") == 1) endTime = "0" + endTime;
-			LocalTime time1 = LocalTime.parse(endTime, hhmmssFormatter);
-			end =  ((time1.getHour() * 60 * 60) + (time1.getMinute() * 60) + time1.getSecond());
-		}
-		
 		return play(mrl, start, end);
 		
 	}
Index: TXM/trunk/org.txm.backtomedia.rcp/src/org/txm/backtomedia/editors/player/MediaPlayerEditor.java
===================================================================
--- TXM/trunk/org.txm.backtomedia.rcp/src/org/txm/backtomedia/editors/player/MediaPlayerEditor.java	(revision 3421)
+++ TXM/trunk/org.txm.backtomedia.rcp/src/org/txm/backtomedia/editors/player/MediaPlayerEditor.java	(revision 3422)
@@ -115,7 +115,7 @@
 	
 	@Override
 	public boolean isDirty() {
-		return true;// player.isMediaLoaded();
+		return false; // player.isMediaLoaded();
 	}
 	
 	/**
Index: TXM/trunk/org.txm.annotation.rcp/src/org/txm/annotation/rcp/editor/AnnotationExtension.java
===================================================================
--- TXM/trunk/org.txm.annotation.rcp/src/org/txm/annotation/rcp/editor/AnnotationExtension.java	(revision 3421)
+++ TXM/trunk/org.txm.annotation.rcp/src/org/txm/annotation/rcp/editor/AnnotationExtension.java	(revision 3422)
@@ -39,7 +39,7 @@
 	
 	private SelectionListener defaultListener;
 	
-	private ToolItem saveButton;
+	//private ToolItem saveButton;
 	
 	public static final String GROUP_NAME = "Annotation";
 	
@@ -48,14 +48,14 @@
 		return GROUP_NAME;
 	}
 	
-	/**
-	 * use this to enable/disable the button
-	 * 
-	 * @return
-	 */
-	public ToolItem getSaveButton() {
-		return saveButton;
-	}
+//	/**
+//	 * use this to enable/disable the button
+//	 * 
+//	 * @return
+//	 */
+//	public ToolItem getSaveButton() {
+//		return saveButton;
+//	}
 	
 	/**
 	 * install the annotation start button and dropdown list
@@ -144,31 +144,31 @@
 				openCloseSelectionListener, modes, listeners);
 		controlArea.setLayout(new GridLayout(1, true));
 		
-		saveButton = new ToolItem(editor.getTopToolbar(), SWT.PUSH);
-		saveButton.setText("Save annotations");
-		//saveButton.setImage(IImageKeys.getImage(IImageKeys.PENCIL_SAVE));
-		saveButton.addSelectionListener(new SelectionListener() {
-			
-			@Override
-			public void widgetSelected(SelectionEvent e) {
-				try {
-					notifyDoSave();
-				}
-				catch (Exception e1) {
-					Log.printStackTrace(e1);
-				}
-			}
-			
-			@Override
-			public void widgetDefaultSelected(SelectionEvent e) {}
-		});
-		saveButton.setEnabled(false);
+//		saveButton = new ToolItem(editor.getTopToolbar(), SWT.PUSH);
+//		saveButton.setText("Save annotations");
+//		//saveButton.setImage(IImageKeys.getImage(IImageKeys.PENCIL_SAVE));
+//		saveButton.addSelectionListener(new SelectionListener() {
+//			
+//			@Override
+//			public void widgetSelected(SelectionEvent e) {
+//				try {
+//					notifyDoSave();
+//				}
+//				catch (Exception e1) {
+//					Log.printStackTrace(e1);
+//				}
+//			}
+//			
+//			@Override
+//			public void widgetDefaultSelected(SelectionEvent e) {}
+//		});
+//		saveButton.setEnabled(false);
 	}
 	
 	public void closeAreasPanel() {
 		editor.getTopToolbar().setVisible(GROUP_NAME, false);
 		editor.getTopToolbar().getOpenCloseButton().setSelection(false);
-		saveButton.setEnabled(false);
+//		saveButton.setEnabled(false);
 	}
 	
 	public void openAnnotationMode(AnnotationArea aa, int position) throws Exception {
@@ -268,11 +268,13 @@
 	
 	@Override
 	public boolean isDirty() throws Exception {
-		boolean dirty = false;
-		for (AnnotationArea aa : annotationAreas) {
-			dirty = dirty || aa.isDirty();
-		}
-		return dirty;
+		return false;
+		
+//		boolean dirty = false;
+//		for (AnnotationArea aa : annotationAreas) {
+//			dirty = dirty || aa.isDirty();
+//		}
+//		return dirty;
 	}
 	
 	@Override
@@ -284,74 +286,74 @@
 	public void notifyDoSave() throws Exception {
 		
 		//		if (needToUpdateIndexes) {
-		JobHandler job = new JobHandler("Updating corpus indexes and editions", true) {
-			
-			@Override
-			protected IStatus run(IProgressMonitor monitor) {
-				
-				this.runInit(monitor);
-				
-				try {
-					monitor.setTaskName("Updating corpus XML-TXM files");
-					
-					Log.info("Saving annotations...");
-					boolean needToUpdateIndexes = false;
-					boolean needToUpdateEditions = false;
-					// System.out.println("Saving annotations...");
-					if (annotationAreas != null && annotationAreas.size() > 0) {
-						for (AnnotationArea aa : annotationAreas) {
-							needToUpdateIndexes = needToUpdateIndexes 
-									|| (aa.isDirty() 
-											&& aa.save()
-											&& aa.needToUpdateIndexes());
-							needToUpdateEditions = needToUpdateEditions || aa.needToUpdateEditions();
-						}
-					}
-					
-					if (needToUpdateIndexes) {
-						final MainCorpus corpus = editor.getResult().getFirstParent(MainCorpus.class);
-						monitor.setTaskName("Updating corpus indexes and editions");
-						if (corpus != null && UpdateCorpus.update(corpus, needToUpdateEditions) != null) {
-							monitor.worked(50);
-							this.syncExec(new Runnable() {
-								
-								@Override
-								public void run() {
-									Log.info("Done.");
-									CorporaView.refreshObject(corpus);
-									if (!saveButton.isDisposed()) {
-										saveButton.setEnabled(false);
-									}
-								}
-							});
-							return Status.OK_STATUS;
-						}
-						else {
-							monitor.worked(50);
-							Log.warning("Fail to update corpus. Aborting");
-							Log.warning("Fix XML-TXM files and call command 'UpdateCorpus'");
-							return Status.CANCEL_STATUS;
-						}
-					} else {
-						this.syncExec(new Runnable() {
-							
-							@Override
-							public void run() {
-								Log.info("Done.");
-								if (!saveButton.isDisposed()) {
-									saveButton.setEnabled(false);
-								}
-							}
-						});
-						return Status.OK_STATUS;
-					}
-				} catch(ThreadDeath ex) {
-					Log.warning(TXMUIMessages.executionCanceled);
-					return Status.CANCEL_STATUS;
-				}
-			}
-		};
-		job.schedule();
+//		JobHandler job = new JobHandler("Updating corpus indexes and editions", true) {
+//			
+//			@Override
+//			protected IStatus run(IProgressMonitor monitor) {
+//				
+//				this.runInit(monitor);
+//				
+//				try {
+//					monitor.setTaskName("Updating corpus XML-TXM files");
+//					
+//					Log.info("Saving annotations...");
+//					boolean needToUpdateIndexes = false;
+//					boolean needToUpdateEditions = false;
+//					// System.out.println("Saving annotations...");
+//					if (annotationAreas != null && annotationAreas.size() > 0) {
+//						for (AnnotationArea aa : annotationAreas) {
+//							needToUpdateIndexes = needToUpdateIndexes 
+//									|| (aa.isDirty() 
+//											&& aa.save()
+//											&& aa.needToUpdateIndexes());
+//							needToUpdateEditions = needToUpdateEditions || aa.needToUpdateEditions();
+//						}
+//					}
+//					
+//					if (needToUpdateIndexes) {
+//						final MainCorpus corpus = editor.getResult().getFirstParent(MainCorpus.class);
+//						monitor.setTaskName("Updating corpus indexes and editions");
+//						if (corpus != null && UpdateCorpus.update(corpus, needToUpdateEditions) != null) {
+//							monitor.worked(50);
+//							this.syncExec(new Runnable() {
+//								
+//								@Override
+//								public void run() {
+//									Log.info("Done.");
+//									CorporaView.refreshObject(corpus);
+//									if (!saveButton.isDisposed()) {
+//										saveButton.setEnabled(false);
+//									}
+//								}
+//							});
+//							return Status.OK_STATUS;
+//						}
+//						else {
+//							monitor.worked(50);
+//							Log.warning("Fail to update corpus. Aborting");
+//							Log.warning("Fix XML-TXM files and call command 'UpdateCorpus'");
+//							return Status.CANCEL_STATUS;
+//						}
+//					} else {
+//						this.syncExec(new Runnable() {
+//							
+//							@Override
+//							public void run() {
+//								Log.info("Done.");
+//								if (!saveButton.isDisposed()) {
+//									saveButton.setEnabled(false);
+//								}
+//							}
+//						});
+//						return Status.OK_STATUS;
+//					}
+//				} catch(ThreadDeath ex) {
+//					Log.warning(TXMUIMessages.executionCanceled);
+//					return Status.CANCEL_STATUS;
+//				}
+//			}
+//		};
+//		job.schedule();
 		//		}
 	}
 	
@@ -359,20 +361,20 @@
 	public void notifyDispose() throws Exception {
 		
 		//FIXME MD: I have to do this because Eclipse is not asking for editor saves before exiting the app - BUG
-		try {
-			boolean annotationsDirty = false;
-			for (AnnotationArea aa : annotationAreas) {
-				annotationsDirty = annotationsDirty || aa.isDirty();
-			}
-			if (annotationsDirty) {
-				boolean doSave = MessageDialog.openQuestion(this.editor.getShell(), "Annotations not saved", "Do you want to save the annotations before closing the editor?");
-				if (doSave) {
-					notifyDoSave();
-				}
-			}
-		} catch(Exception e) {
-			Log.printStackTrace(e);
-		}
+//		try {
+//			boolean annotationsDirty = false;
+//			for (AnnotationArea aa : annotationAreas) {
+//				annotationsDirty = annotationsDirty || aa.isDirty();
+//			}
+//			if (annotationsDirty) {
+//				boolean doSave = MessageDialog.openQuestion(this.editor.getShell(), "Annotations not saved", "Do you want to save the annotations before closing the editor?");
+//				if (doSave) {
+//					notifyDoSave();
+//				}
+//			}
+//		} catch(Exception e) {
+//			Log.printStackTrace(e);
+//		}
 		
 		for (AnnotationArea aa : annotationAreas) {
 			aa._close();
Index: TXM/trunk/org.txm.annotation.core/src/org/txm/annotation/core/AnnotationEnginesManager.java
===================================================================
--- TXM/trunk/org.txm.annotation.core/src/org/txm/annotation/core/AnnotationEnginesManager.java	(revision 3421)
+++ TXM/trunk/org.txm.annotation.core/src/org/txm/annotation/core/AnnotationEnginesManager.java	(revision 3422)
@@ -1,12 +1,18 @@
 package org.txm.annotation.core;
 
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+
 import org.eclipse.core.runtime.IConfigurationElement;
 import org.eclipse.core.runtime.IProgressMonitor;
 import org.eclipse.core.runtime.Platform;
 import org.eclipse.osgi.util.NLS;
+import org.txm.Toolbox;
 import org.txm.core.engines.EngineType;
 import org.txm.core.engines.EnginesManager;
 import org.txm.objects.CorpusBuild;
+import org.txm.objects.Project;
 import org.txm.utils.logger.Log;
 
 
@@ -99,4 +105,49 @@
 		
 		return size() > 0;
 	}
+	
+	public boolean isSaveNeeded() {
+		
+		for (AnnotationEngine a : values()) {
+			for (Project project : Toolbox.workspace.getProjects()) {
+				for (CorpusBuild corpus : project.getCorpora()) {
+					if (a.hasAnnotationsToSave(corpus)) {
+						return true;
+					}
+				}
+			}
+		}
+		return false;
+	}
+
+	public List<AnnotationEngine> getEnginesWithSaveNeeded() {
+		
+		List<AnnotationEngine> tmp = new ArrayList<AnnotationEngine>();
+		for (AnnotationEngine a : values()) {
+			for (Project project : Toolbox.workspace.getProjects()) {
+				for (CorpusBuild corpus : project.getCorpora()) {
+					if (a.hasAnnotationsToSave(corpus)) {
+						tmp.add(a);
+					}
+				}
+			}
+		}
+		return tmp;
+	}
+	
+	public HashMap<CorpusBuild, ArrayList<AnnotationEngine>> getEnginesWithSaveNeededPerCorpus() {
+		
+		HashMap<CorpusBuild, ArrayList<AnnotationEngine>> tmp = new HashMap<CorpusBuild, ArrayList<AnnotationEngine>>();
+		for (AnnotationEngine a : values()) {
+			for (Project project : Toolbox.workspace.getProjects()) {
+				for (CorpusBuild corpus : project.getCorpora()) {
+					if (a.hasAnnotationsToSave(corpus)) {
+						if (!tmp.containsKey(corpus)) tmp.put(corpus, new ArrayList<>());
+						tmp.get(corpus).add(a);
+					}
+				}
+			}
+		}
+		return tmp;
+	}
 }
Index: TXM/trunk/org.txm.annotation.kr.core/src/org/txm/annotation/kr/core/storage/temporary/TemporaryAnnotationManager.java
===================================================================
--- TXM/trunk/org.txm.annotation.kr.core/src/org/txm/annotation/kr/core/storage/temporary/TemporaryAnnotationManager.java	(revision 3421)
+++ TXM/trunk/org.txm.annotation.kr.core/src/org/txm/annotation/kr/core/storage/temporary/TemporaryAnnotationManager.java	(revision 3422)
@@ -73,6 +73,8 @@
 	private EntityManager em;
 	
 	private MainCorpus corpus;
+
+	private EntityManagerFactory emf;
 	
 	public TemporaryAnnotationManager(MainCorpus corpus) {
 		this.corpus = corpus;
@@ -100,6 +102,9 @@
 		if (em != null) {
 			em.close();
 		}
+		if (emf != null) {
+			emf.close();
+		}
 	}
 	
 	
@@ -301,12 +306,13 @@
 	 * @throws Exception
 	 */
 	public List<Annotation> getAnnotations(AnnotationType refType, int startPosition, int endPosition, String value) {
-		String query = "SELECT annot FROM Annotation AS annot "
-				+ "WHERE annot.PK.refType LIKE '" + refType.getId() + "'";
+		String query = "SELECT annot FROM Annotation AS annot WHERE annot.PK.refType LIKE '" + refType.getId() + "'";
 		if (startPosition >= 0)
 			query += " AND annot.PK.startpos = " + startPosition;
+		
 		if (endPosition >= 0)
 			query += " AND annot.PK.endpos = " + endPosition;
+		
 		if (value != null)
 			query += " AND annot.refVal LIKE ':" + value + "' ";
 		
@@ -501,7 +507,7 @@
 		// infos.getManagedClassNames().add("org.txm.annotation.TypedValue");
 		// pp.generateSchema(infos, properties);
 		
-		EntityManagerFactory emf = pp.createEntityManagerFactory(DatabasePersistenceManager.PERSISTENCE_UNIT_NAME, properties);
+		emf = pp.createEntityManagerFactory(DatabasePersistenceManager.PERSISTENCE_UNIT_NAME, properties);
 		
 		em = emf.createEntityManager();
 		
Index: TXM/trunk/org.txm.annotation.kr.core/src/org/txm/annotation/kr/core/KRAnnotationEngine.java
===================================================================
--- TXM/trunk/org.txm.annotation.kr.core/src/org/txm/annotation/kr/core/KRAnnotationEngine.java	(revision 3421)
+++ TXM/trunk/org.txm.annotation.kr.core/src/org/txm/annotation/kr/core/KRAnnotationEngine.java	(revision 3422)
@@ -12,6 +12,7 @@
 import org.osgi.service.prefs.BackingStoreException;
 import org.osgi.service.prefs.Preferences;
 import org.txm.annotation.core.AnnotationEngine;
+import org.txm.annotation.kr.core.preferences.KRAnnotationPreferences;
 import org.txm.annotation.kr.core.repository.KnowledgeRepository;
 import org.txm.annotation.kr.core.repository.KnowledgeRepositoryManager;
 import org.txm.annotation.kr.core.repository.SQLKnowledgeRepository;
@@ -427,7 +428,7 @@
 	@Override
 	public void notify(TXMResult r, String state) {
 		
-		if (r instanceof MainCorpus && "clean".equals(state)) {
+		if (r instanceof MainCorpus && "before_clean".equals(state)) {
 			
 			MainCorpus c = (MainCorpus) r;
 			
@@ -439,11 +440,13 @@
 				Log.fine("cleaning KR: " + krname);
 				KRAnnotationEngine.unregisterKnowledgeRepositoryName(c, krname);
 			}
+			
 			if (c.getProjectDirectory() == null || !c.getProjectDirectory().exists()) {
 				return;
 			}
 			
 			if (ams.get(c) != null && ams.get(c).tempManager != null && ams.get(c).tempManager.getEntityManager() != null ) {
+				Log.fine("closing temporary annotations database of: "+c);
 				ams.get(c).tempManager.close(); // free files
 			}
 			
@@ -451,6 +454,34 @@
 			if (buildDirectory.exists()) {
 				DeleteDir.deleteDirectory(buildDirectory);
 			}
+		} else if (r instanceof MainCorpus && "clean".equals(state)) {
+			
+			MainCorpus c = (MainCorpus) r;
+			
+			if (c.getProject() == null || c.getProject().getDoUpdate()) {
+				return;
+			}
+			
+			for (String krname : KRAnnotationEngine.getKnowledgeRepositoryNames(c)) {
+				Log.fine("cleaning KR: " + krname);
+				KRAnnotationEngine.unregisterKnowledgeRepositoryName(c, krname);
+			}
+			
+			
+			
+			if (c.getProjectDirectory() == null || !c.getProjectDirectory().exists()) {
+				return;
+			}
+			
+			if (ams.get(c) != null && ams.get(c).tempManager != null && ams.get(c).tempManager.getEntityManager() != null ) {
+				Log.fine("closing temporary annotations databse of: "+c);
+				ams.get(c).tempManager.close(); // free files
+			}
+			
+			File buildDirectory = new File(c.getProjectDirectory(), "temporary_annotations/" + c.getID());
+			if (buildDirectory.exists()) {
+				DeleteDir.deleteDirectory(buildDirectory);
+			}
 		}
 		else if (r instanceof Project && "clean".equals(state)) {
 			
@@ -514,6 +545,9 @@
 	
 	@Override
 	public boolean hasAnnotationsToSave(CorpusBuild corpus) {
+		
+		if (KRAnnotationPreferences.getInstance().getBoolean(KRAnnotationPreferences.PRESERVE_ANNOTATIONS)) return false;
+		
 		if (!ams.containsKey(corpus)) return false; // no annotation manager -> not annotations to save
 		return ams.get(corpus).hasChanges();
 	}
Index: TXM/trunk/org.txm.annotation.kr.core/src/org/txm/annotation/kr/core/repository/KnowledgeRepositoryManager.java
===================================================================
--- TXM/trunk/org.txm.annotation.kr.core/src/org/txm/annotation/kr/core/repository/KnowledgeRepositoryManager.java	(revision 3421)
+++ TXM/trunk/org.txm.annotation.kr.core/src/org/txm/annotation/kr/core/repository/KnowledgeRepositoryManager.java	(revision 3422)
@@ -343,9 +343,8 @@
 			kr.deleteType(annotType);
 		}
 		repositories.remove(kr.getName());
+		kr.close();
 	}
 	
 	
-	
-	
 }
